# threading must be imported before WiiMOL_Thread
# otherwise there may be a runtime error

from thread import *

#import ttk

import os
import sys
import Shared
import WiiMOL_GUI
import Pointer
#import Overlay
#import WiiMOL_Thread
#import WiimoteDevice

import Device

#sys.path.append('./build/lib.win32-2.6')
#import WiimoteAPI	#precompiled API.

import Input_Thread
import cameraCallback
import Bookmarks
import ZBufferHandler
import socket
import struct
import pickle
import subprocess

#from Tkinter import *
#import tkFileDialogdata, addr
#import tkMessageBox

import Input_Function
import pygameRecvThread

from pymol import cmd
import pymol

class WiiMOL:
	root = None
	def __init__(self):
		self.bms = Bookmarks.Bookmarks()
		cmd.do("set label_color, yellow")
		cmd.do("set label_font_id, 4")
	#lock = allocate_lock()
		recievingThread = pygameRecvThread.recieving_Thread()
		print "thread allocated"
		recievingThread.start()
		print "thread started"
		while(Shared.JoystickData == None):
			print "blah"
			data = None
			while(data == None):
				data = Shared.dataStorage
			length = struct.unpack_from("i",data)[0]
			print length
			firstData = struct.unpack_from("i" + length * "fffffffffffffffff",data)
			print firstData
			i = 1;
			j = 0;
			k = 0;
			finalData = []
			finalData.append([])
			while i < 17*length + 1 :
				if(j == 17):
					k += 1
					j = 0
					finalData.append([])
					
				finalData[k].append(  firstData[i]);
				j += 1
				i += 1
			Shared.JoystickData = [length,finalData]
			pass
		print "blah2"
		Shared.bms = self.bms
		Shared.camera = cameraCallback.Cameras()
		Shared.depthTracker = ZBufferHandler.ZBufferHandler()
		Shared.Resi_Dictionary = dict()
		Shared.Extent_Dictionary = dict()
		Shared.Atom_list = []
		#callbacks

		guiCallback = WiiMOL_GUI.callback_gui()
		Shared.callbackList.append(Shared.camera)
		cmd.load_callback(guiCallback,'Pymol Controllers')
		#		wiimote_info = WiimoteAPI.Update()
		#		wiimote_count = 0


		
		wiimote_states = []
		state = cmd.get_names("objects")
		for i in state:
			try:
				if not (("/" +i) in Shared.Ignore_Extents):
					residue_list = dict()
					atoms = cmd.get_model(i)
					for atom in atoms.atom:
						if not( atom.chain in residue_list.keys()):
							residue_list[atom.chain] = dict()  #allows us to keep track of a bit
						if not( atom.resi in residue_list[atom.chain].keys()): #of hierarchical bounding, so selecting is not such a drain
							residue_list[atom.chain][atom.resi] = []
						if not( atom.name in residue_list[atom.chain][atom.resi]):
							residue_list[atom.chain][atom.resi].append(atom.name)
						if not( atom.name in Shared.Atom_list):
							Shared.Atom_list.append("/" +i + "//" +\
							      atom.chain + "/" + atom.resi + "/" +atom.name)
					Shared.Resi_Dictionary[i] = residue_list
			except pymol.CmdException:
				if not ("/" + i) in Shared.Ignore_Extents:
					Shared.Ignore_Extents.append("/" + i)
		Input_Function.recompileExtents()
		controllers = []
		pointers = []
		Shared.pointer_position = []
		cmd.disable('Pymol_Controller')
 		cmd.enable('Pymol_Controller')
		
		#		if not wiimote_info == None:
		#			[wiimote_count, wiimote_states] = wiimote_info
		#		for x in range(0, wiimote_count):
		#			wiimote1 = WiimoteDevice.WiimoteDevice(x,x) #controller index, wiimote driver index
		#			pointers.append(Pointer.callback_pointer(x,self))
		#			Shared.pointer_position.append([0,0,0])
		#			cmd.load_callback(pointers[x], 'pointer' + str(x))
		#			controllers.append(wiimote1)
		
		deviceCount = Shared.JoystickData[0]#need to get info from child for this
		for x in range(deviceCount):
			print "device initialized"
			dev1 = Device.Device(x,x)
			print "device done"
			controllers.append(dev1)
			print "device done"
			Shared.pointer_position.append([0,0,0])
			pointers.append(Pointer.callback_pointer(x,self))
			Shared.callbackList.append(pointers[x])

		cmd.zoom()

		thread = Input_Thread.Input_Thread(len(controllers), controllers).start()
		thread.start()


		#		
		#	def heavySave(self,*args):
		#		print "heavy save"
		#		tempRoot = Tk()
		#		tempRoot.title = "Heavy Save Options"
		#		self.saveframe = ttk.Frame(tempRoot, padding="20 10 20 10")
		#		self.saveframe.grid(column=0, row=0, sticky=(N, W, E, S))
		#		self.saveframe.columnconfigure(0, weight=1)
		#		self.saveframe.rowconfigure(0, weight=1)
		#		self.selection = ''
		#		self.state = ''
		#		self.format = ''
		#		selection_entry = ttk.Entry(self.saveframe, width=10, textvariable=self.selection)
		#		state_entry = ttk.Entry(self.saveframe, width=10, textvariable=self.state)
		#		format_entry = ttk.Entry(self.saveframe, width=10, textvariable=self.format)
		#		
		#		selection_entry.grid(column=2, row=1, sticky=(W, E))
		#		state_entry.grid(column=2, row=2, sticky=(W, E))
		#		format_entry.grid(column=2, row=3, sticky=(W, E))
		#		
		#		ttk.Label(self.saveframe, text="selection").grid(column=1, row=1, sticky=(W, E))
		#		ttk.Label(self.saveframe, text="state").grid(column=1, row=2, sticky=(W, E))
		#		ttk.Label(self.saveframe, text="format").grid(column=1, row=3, sticky=(W, E))
		#		saveButton = Button( self.saveframe, text="save", command=lambda s=self: self.excHeavySave(s))
		#		saveButton.grid(column = 3, row = 3, sticky =(N, W, E, S))
		#		
		
		
	def excHeavySave(self,*args):
		print "actually doing heavy save"
		hSaveLoc = tkFileDialog.asksaveasfilename(defaultextension = '' , initialdir = 'C:\\', initialfile = '' , parent = self.root, title = 'Heavy Save')
		Shared.bms.pymolMainDumpLoc = hSaveLoc
		print self.selection
		FILE = open(hSaveLoc + ".wMol","wb")
		pickle.dump(Shared.bms, FILE)
		FILE.close()
		argument=''
		argument+=hSaveLoc
		argument+=' '
		argument+=self.selection  #I know it is ugly to use globals for this, but the button lambda form does not appear to support multiple variables.
		argument+=' '				#if, at some point we discover that we can put multiple variables reliably in the button lambda, we should change this.
		argument+=self.state
		argument+=' '
		argument+=self.format
		cmd.save(hSaveLoc + ' ' + self.selection + ' ' + self.state + ' ' + self.format)
						            #we might want to find out if they would find it useful to use the more complex save functionality offered by pymol, and 
									# if so to create a tk interface designed around such a need, with checkboxes and text areas for their entry, and saving
									# upon the activation of a button.
		
	def lightSave(self,*args):
		print "light save"
		lSaveLoc = tkFileDialog.asksaveasfilename(defaultextension = '' , initialdir = 'C:\\', initialfile = '' , parent = self.root, title = 'Light Save')
		Shared.pymolMainDumpLoc = none
		FILE = open(lSaveLoc + ".wMol","wb")
		pickle.dump(Shared.bms, FILE)
		FILE.close()
	
	def load(self,*args):
		print "load"
		loadLoc = tkFileDialog.askopenfilename(defaultextension = '' , initialdir = 'C:\\', initialfile = '', parent = self.root, filetypes=[("wiiMol storage file",".wMol")], title = 'Load file')
		if (loadLoc != None):
			FILE = open(loadLoc,"r")
			Shared.bms = pickle.load(FILE)
			FILE.close()
			if ( Shared.bms.pymolMainDumpLoc != None ):
				cmd.load(loadLoc[:-5])
				
	def fileCancel(self,*args):
		self.mainfileMenu.unpost()
		
	def calibrateAcc(self,*args):
		print "press A on the wiimote you wish to calibrate"
		Shared.calibration = True
		Shared.calibrationType = 0
		Shared.calibrationStage = 0
			
	def calibrateCamera(self,*args):
		print "press A on the wiimote you wish to calibrate"
		Shared.calibration = True
		Shared.calibrationType = 1
		Shared.calibrationStage = 0

#	def startTk(self, tkobject):

#		print "tk is not right!"

#		self.mainframe = Tkinter.Frame(self.root)
#		self.mainframe.grid(column=0, row=0, sticky=(N, W, E, S))
#		self.mainframe.columnconfigure(0, weight=1)
#		self.mainframe.rowconfigure(0, weight=1)




#		tkobject.menuBar.addmenuitem('WiiMOL','command','Save Heavy', label = 'Save Heavy',command=self.heavySave)
#		tkobject.menuBar.addmenuitem('WiiMOL','command','Save Light', label = 'Save Light', command=self.lightSave)
#		tkobject.menuBar.addmenuitem('WiiMOL','command','Load', label = 'Load',command = self.load)






		#button = ttk.Button(, text="Hello World").grid()
